#include "StdAfx.h"
#include "NMImgCheckButton.h"


CNMImgCheckButton::CNMImgCheckButton()
{	
    m_nMask = 0;
    m_rectButton.SetRectEmpty();
    m_rectButtonPos.SetRectEmpty();
	m_bCursorOnButton	= FALSE;
	m_bHover			= FALSE;
	m_bChecked			= FALSE;
	m_bPushed			= FALSE;
	m_b3State			= FALSE;
}

CNMImgCheckButton::~CNMImgCheckButton()
{
}

BEGIN_MESSAGE_MAP(CNMImgCheckButton, CButton)
	//{{AFX_MSG_MAP(CKbcButton)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_SETCURSOR()
	ON_MESSAGE(WM_MOUSEHOVER,OnMouseHover)
	ON_MESSAGE(WM_MOUSELEAVE,OnMouseLeave)
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CNMImgCheckButton::PreSubclassWindow()
{
	unsigned int  dwStyle    = 0; 
	unsigned long dwRemove   = 0;
	unsigned long dwNewStyle = 0; 

	dwStyle = ::GetWindowLong(m_hWnd, GWL_STYLE);

	// WS_DISABLED Ӽ Ǿ   ¿ Լ Ѵ..
	if ((dwStyle & WS_DISABLED) != WS_DISABLED)
	{
		dwRemove = BS_AUTO3STATE | BS_3STATE; 	
		// BS_OWNERDRAW Ӽ Ѵ.
		dwNewStyle = (dwStyle & ~dwRemove) | BS_OWNERDRAW;
		::SetWindowLong(m_hWnd, GWL_STYLE, dwNewStyle);
	}
	CButton::PreSubclassWindow();

}

void CNMImgCheckButton::SetChangeStates()
{
	OutputDebugString(_T("\r\n##### CNMImgCheckButton::SetChangeStates #####\r\n"));

	if (m_b3State) // BS_AUTO3STATE, BS_O3STATE Ӽ̸...
		m_bChecked = (m_bChecked + 1) % 3;
	else 
		m_bChecked = (m_bChecked + 1) % 2;
}


BOOL CNMImgCheckButton::GetCheck() const
{
	return m_bChecked;
}

void CNMImgCheckButton::SetCheck(int nCheck) 
{
	if (nCheck==0)
	{
		m_bChecked=FALSE;
	}
	else
	{
		m_bChecked=TRUE;
	}
	Invalidate();
}

void CNMImgCheckButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	// get DC from LPDRAWITEMSTRUCT..
	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	if( m_bChecked == FALSE )
	{
		if(m_bHover)
			m_bmpImage.Draw(pDC,BUTTON_UNCHECKE_HOVER,0,0,m_nMask);
		else
			m_bmpImage.Draw(pDC,BUTTON_UNCHECK,0,0,m_nMask);
	}
	else
	{
		if(m_bHover)
			m_bmpImage.Draw(pDC,BUTTON_CHECKED_HOVER,0,0,m_nMask);
		else
			m_bmpImage.Draw(pDC,BUTTON_CHECKED,0,0,m_nMask);
	}
	ReleaseDC(pDC);
}

void CNMImgCheckButton::SetBitmapFile(CString strFileName,UINT nMask)
{
	m_bmpImage.LoadUnitedBitmap(strFileName);
	m_nMask = nMask;

	// get button info..
	m_rectButton.left	= 0;
	m_rectButton.top	= 0;
	m_rectButton.right	= m_bmpImage.GetSliceWidth();
	m_rectButton.bottom	= m_bmpImage.GetHeight();
	////////////////////////////////////////////////////////////////


	// resize button size.
	// if button size is smaller than button image then we enlarge button size..
	CWnd *pWnd = this->GetParent();
	GetWindowRect(&m_rectButtonPos);
	pWnd->ScreenToClient(m_rectButtonPos);
	m_rectButtonPos.right	= m_rectButtonPos.left + m_bmpImage.GetSliceWidth();
	m_rectButtonPos.bottom	= m_rectButtonPos.top  + m_bmpImage.GetHeight();
	MoveWindow(m_rectButtonPos);
	////////////////////////////////////////////////////////////////
}


void CNMImgCheckButton::OnMouseMove(UINT nFlags, CPoint point) 
{
	// we wanna get WM_MOUSEHOVER,WM_MOUSELEAVE message, so we call _TrackMouseEvent
	if( m_bCursorOnButton == FALSE )
	{
		TRACKMOUSEEVENT tme;
		ZeroMemory(&tme,sizeof(TRACKMOUSEEVENT));
		tme.cbSize = sizeof(tme);
		tme.hwndTrack = m_hWnd;
		tme.dwFlags = TME_LEAVE|TME_HOVER;
		tme.dwHoverTime = 1;
		m_bCursorOnButton = _TrackMouseEvent(&tme);
	}

	CButton::OnMouseMove(nFlags, point);
}


LRESULT CNMImgCheckButton::OnMouseHover(WPARAM wparam, LPARAM lparam)
{
	m_bHover = TRUE;

	Invalidate();
	return 0L;
}

LRESULT CNMImgCheckButton::OnMouseLeave(WPARAM wparam, LPARAM lparam)
{

	m_bHover			= FALSE;

	Invalidate();
	return 0L;
}



void CNMImgCheckButton::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// if button state is disable we do not call CButton::OnLButtonDown funtion..

	
	m_bPushed = TRUE;
	CButton::OnLButtonDown(nFlags, point);

}
void CNMImgCheckButton::OnLButtonUp(UINT nFlags, CPoint point) 
{
	RECT rc = {0};
	//  ư ȿ  콺 ư  ...
	if (m_bPushed == TRUE) {
		::GetClientRect(m_hWnd, &rc);
		// ȿ , Ǹ ư ° Ѵ.
		if (::PtInRect(&rc, (POINT)point))
			SetChangeStates();
	}
	// ư  Ǹ, "0" ʱȭѴ.
	m_bPushed = FALSE;

	CButton::OnLButtonUp(nFlags, point);
}


BOOL CNMImgCheckButton::PreTranslateMessage(MSG* pMsg) 
{
	// to showing a tooltip message, call RelayEvent if m_ToolTip has created.

	return CButton::PreTranslateMessage(pMsg);
}


BOOL CNMImgCheckButton::OnEraseBkgnd(CDC* pDC) 
{

	return TRUE;
}

